/*
check-n-send.js
       ,
  ,   ,   
  .
,   NHSMS   ,  
   %PATH%
*/

//  

var disk_free_limit = 15; //     , %%
var drive_status_ok = "OK"; //      OK
var memory_usage_limit = 85; //   , %%
var cpu_total_percent_limit = 85; //   , %%

function check_computer(computer_name) {
    var error_text = "";
    var wmi = GetObject("winmgmts:{impersonationLevel=impersonate}!\\\\"+
        computer_name+"\\root\\cimv2");
    var gb = 1024*1024*1024;

    // Logical disks

    var disks = wmi.ExecQuery("select * from Win32_LogicalDisk where DriveType=3");
    var e = new Enumerator(disks);

    for (; !e.atEnd(); e.moveNext()){
        var size_gb=e.item().Size/gb;
        var free_space_gb=e.item().FreeSpace/gb;
        var free_percentage = free_space_gb * 100 / size_gb;
        WScript.Echo(e.item().DeviceID + 
            " "+ size_gb.toFixed(1)+"GB "+ free_space_gb.toFixed(1)+"GB" +
            " (" + free_percentage.toFixed(1) + "%)" +
            " " + e.item().FileSystem);
        if (free_percentage < disk_free_limit)
            error_text += "Disk " + e.item().DeviceID + " full (" + 
               free_percentage.toFixed(1) + "% free). ";
   
    }

    // Physical drives

    var drives = wmi.ExecQuery("select * from Win32_DiskDrive");
    e = new Enumerator(drives);
    for (; !e.atEnd(); e.moveNext()){
        var size_gb = e.item().Size/gb;
        WScript.Echo(e.item().DeviceID+
            " " + size_gb.toFixed(1) + "GB "+
            " " + e.item().Status);
        if (e.item().Status != drive_status_ok)
            error_text += "Drive " + e.item().DeviceID + " " + 
               e.item().Status +"). ";
    }

    // memory

    var m = wmi.ExecQuery("select * from Win32_PerfFormattedData_PerfOS_Memory");
    e = new Enumerator(m);
    var memory_usage = e.item().PercentCommittedBytesInUse;
    if (memory_usage > memory_usage_limit)
        error_text += "CPU overload (" + cpu_total_percent + "%). ";
    WScript.Echo("Memory usage " + memory_usage + "%");

    // CPU

    var p = wmi.ExecQuery("select * from Win32_PerfFormattedData_PerfOS_Processor where Name='_Total'");
    e = new Enumerator(p);
    var cpu_total_percent = e.item().PercentProcessorTime;
    WScript.Echo("CPU load " + cpu_total_percent + "%");
    if (cpu_total_percent > cpu_total_percent_limit)
        error_text += "CPU overload (" + cpu_total_percent + "%). ";
    return error_text;
}

var error_text = "";
var computer_name = ".";

try {
    error_text = check_computer(computer_name); 
}
catch (e) {
    //     
    error_text = "Failed. ";
}

if (error_text.length) { //   ...
    WScript.Echo(error_text);
    //  NHSMS: nhsmscl.exe  Exec,    . 
    //   ,     Run()
    var wsh_shell = WScript.CreateObject("WScript.Shell");
    var nhsms = wsh_shell.Exec("nhsmscl.exe " + error_text);
    while (!nhsms.StdOut.AtEndOfStream) { 
        var line = nhsms.StdOut.ReadLine();
        WScript.Echo(line);
    }
}
